<template>
  <div class="text-right">
    <v-dialog v-model="dialog" persistent height="auto" width="1300">
      <template v-slot:activator="{ on, attrs }">
        <v-btn
          class="
            button-text
            v-btn v-btn--outlined v-btn--rounded
            theme--light
            v-size--default
            tway-violet--text
          "
          color="coral lighten-2"
          outlined
          v-bind="attrs"
          v-on="on"
        >
          <v-icon
            color="deep-orange accent-4

"
          >
            mdi-chart-areaspline
          </v-icon>

          Seguimiento
        </v-btn>
      </template>

      <v-card :class="'modalSystem'">
        <v-btn icon right @click="dialog = false" class="float-right">
          <v-icon>mdi-close</v-icon>
        </v-btn>
        <v-card>
          <h3 class="text-center">SEGUIMIENTO DE RIESGO</h3>
          <h4 class="text-center font-weight-regular">
            Ingresa nuevo Seguimiento
          </h4>
          <div class="container formSeg">
            <v-row
              :v-if="items.length > 0"
              v-for="(item, index) in items"
              :key="index"
              :class="{ hide: hidden }"
              class="mt-5 formRow"
            >
              <v-col class="col-2">
                <v-text-field
                  v-model="item.riesgo"
                  label="Riesgo"
                  maxlength="15"
                  minlenght="0"
                  :counter="15"
                  outlined
                ></v-text-field>
              </v-col>
              <v-col class="col-2">
                <v-select
                  :items="ocurrencia"
                  label="Ocurrencia"
                  v-model="item.ocurrencia"
                  outlined
                ></v-select>
              </v-col>
              <v-col class="col-2">
                <v-select
                  :items="impacto"
                  label="Impacto"
                  v-model="item.impacto"
                  outlined
                ></v-select>
              </v-col>
              <v-col class="col-2">
                <v-select
                  :items="estado"
                  label="Estado"
                  v-model="item.estado"
                  outlined
                ></v-select>
              </v-col>
              <v-col class="col-2">
                <v-select
                  :items="categoria"
                  label="Categoría"
                  v-model="item.categoria"
                  outlined
                ></v-select>
              </v-col>
              <v-col class="col-2">
                <v-select
                  :items="responsable"
                  label="Responsable"
                  v-model="item.responsable"
                  outlined
                ></v-select>
              </v-col>
              <v-col class="col-2">
                <v-menu
                  v-model="menu2"
                  :close-on-content-click="false"
                  :nudge-right="40"
                  transition="scale-transition"
                  offset-y
                  min-width="auto"
                >
                  <template v-slot:activator="{ on, attrs }">
                    <v-text-field
                      v-model="date"
                      label="Fecha Crítica"
                      prepend-icon="mdi-calendar"
                      readonly
                      outlined
                      v-bind="attrs"
                      v-on="on"
                    ></v-text-field>
                  </template>
                  <v-date-picker
                    v-model="date"
                    @input="menu2 = false"
                  ></v-date-picker>
                </v-menu>
              </v-col>
              <v-col class="col-2">
                <v-menu
                  v-model="menu3"
                  :close-on-content-click="false"
                  :nudge-right="40"
                  transition="scale-transition"
                  offset-y
                  min-width="auto"
                  :min="date"
                >
                  <template v-slot:activator="{ on, attrs }">
                    <v-text-field
                      v-model="date2"
                      label="Fecha Cierre"
                      prepend-icon="mdi-calendar"
                      readonly
                      outlined
                      v-bind="attrs"
                      v-on="on"
                      :min="date"
                    ></v-text-field>
                  </template>
                  <v-date-picker
                    v-model="date2"
                    @input="menu3 = false"
                    :min="date"
                  ></v-date-picker>
                </v-menu>
              </v-col>
              <v-col class="col-2">
                <v-select
                  :items="estrategia"
                  label="Estrategia"
                  v-model="item.estrategia"
                  outlined
                ></v-select>
              </v-col>
              <v-col class="col-6">
                <v-text-field
                  v-model="item.descripcion"
                  label="Descripción"
                  maxlength="50"
                  minlenght="0"
                  :counter="15"
                  outlined
                ></v-text-field>
              </v-col>
              <v-col class="col-12">
                <v-text-field
                  v-model="item.plan"
                  label="Plan"
                  maxlength="50"
                  minlenght="0"
                  :counter="15"
                  outlined
                ></v-text-field>
              </v-col>
            </v-row>
          </div>
          <v-divider class="my-5"></v-divider>
          <div class="container">
            <h4 class="text-center font-weight-regular">
              Listado de Seguimiento
            </h4>
            <v-simple-table class="table mt-2" fixed-header>
              <template>
                <thead>
                  <tr>
                    <th class="text-center" scope="col">ID</th>
                    <th class="text-center" scope="col">Riesgo</th>
                    <th class="text-center" scope="col">Ocurrencia</th>
                    <th class="text-center" scope="col">Impacto</th>
                    <th class="text-center" scope="col">Estado</th>
                    <th class="text-center" scope="col">Estrategia</th>
                    <th class="text-center" scope="col">Responsable</th>
                    <th class="text-center" scope="col">Fecha Crítica</th>
                    <th class="text-center" width="150" scope="col">
                      Acciones
                    </th>
                  </tr>
                </thead>
                <tbody>
                  <template
                    :v-if="items.length > 0"
                    v-for="(item, index) in items"
                  >
                    <tr
                      :key="index"
                      :class="item.isVisible ? activeClass : hidden"
                      class="edit_row"
                      style="border-bottom: thin solid rgba(0, 0, 0, 0.12)"
                    >
                      <td class="text-center">{{ index + 1 }}</td>
                      <td class="text-center">
                        <v-text-field
                          v-model="item.riesgo"
                          label="Riesgo"
                          maxlength="15"
                          minlenght="0"
                          :counter="15"
                          outlined
                        ></v-text-field>
                      </td>
                      <td class="text-center">
                        <v-select
                          :items="ocurrencia"
                          label="Ocurrencia"
                          v-model="item.ocurrencia"
                          outlined
                        ></v-select>
                      </td>
                      <td class="text-center">
                        <v-select
                          :items="estado"
                          label="Estado"
                          v-model="item.estado"
                          outlined
                        ></v-select>
                      </td>
                      <td class="text-center">
                        <v-select
                          :items="categoria"
                          label="Categoría"
                          v-model="item.categoria"
                          outlined
                        ></v-select>
                      </td>
                      <td class="text-center">
                        <v-select
                          :items="estrategia"
                          label="Estrategia"
                          v-model="item.estrategia"
                          outlined
                        ></v-select>
                      </td>
                      <td class="text-center">
                        <v-select
                          :items="responsable"
                          label="Responsable"
                          v-model="item.responsable"
                          outlined
                        ></v-select>
                      </td>
                      <td class="text-center">
                        <v-text-field
                          v-model="date"
                          label="Fecha Crítica"
                          prepend-icon="mdi-calendar"
                          outlined
                        ></v-text-field>
                      </td>
                      <td class="text-center buttons">
                        <v-tooltip right>
                          <template v-slot:activator="{ on, attrs }">
                            <v-btn
                              icon
                              color="primary"
                              class="edit"
                              @click="saveItem(item)"
                              v-bind="attrs"
                              v-on="on"
                            >
                              <v-icon>edit</v-icon>
                            </v-btn>
                          </template>
                          <span>Editar</span>
                        </v-tooltip>
                        <v-tooltip right>
                          <template v-slot:activator="{ on, attrs }">
                            <v-btn
                              icon
                              color="primary"
                              class="save"
                              @click="saveItem(item)"
                              v-bind="attrs"
                              v-on="on"
                            >
                              <v-icon>save</v-icon>
                            </v-btn>
                          </template>
                          <span>Guardar</span>
                        </v-tooltip>
                        <v-tooltip right>
                          <template v-slot:activator="{ on, attrs }">
                            <v-btn
                              icon
                              color="error"
                              v-bind="attrs"
                              v-on="on"
                              @click="removeItem()"
                            >
                              <v-icon>delete</v-icon>
                            </v-btn>
                          </template>
                          <span>Eliminar</span>
                        </v-tooltip>
                        <v-tooltip right>
                          <template v-slot:activator="{ on, attrs }">
                            <v-btn
                              icon
                              color="green"
                              v-bind="attrs"
                              v-on="on"
                              @click="isShow = !isShow"
                            >
                              <v-icon>mdi-eye</v-icon>
                            </v-btn>
                          </template>
                          <span>Ver detalles</span>
                        </v-tooltip>
                      </td>
                    </tr>
                    <tr
                      :class="item.isVisible ? activeClass : hidden"
                      :key="index"
                      class="edit_row"
                      style="border-bottom: thin solid rgba(0, 0, 0, 0.12)"
                      v-show="!isShow"
                    >
                      <th class="text-center">Impacto</th>
                      <th class="text-center">Fecha Cierre</th>
                      <th class="text-center" colspan="4">Descripción</th>
                      <th class="text-center" colspan="3">Plan</th>
                    </tr>
                    <tr
                      :class="item.isVisible ? activeClass : hidden"
                      :key="index"
                      class="edit_row"
                      style="border-bottom: thin solid rgba(0, 0, 0, 0.12)"
                      v-show="!isShow"
                    >
                      <td class="text-center">
                        <v-select
                          :items="impacto"
                          label="Impacto"
                          v-model="item.impacto"
                          outlined
                        ></v-select>
                      </td>
                      <td class="text-center">
                        <v-text-field
                          v-model="date2"
                          label="Fecha Cierre"
                          prepend-icon="mdi-calendar"
                          outlined
                          :min="date"
                        ></v-text-field>
                      </td>
                      <td class="text-center" colspan="4">
                        <v-text-field
                          v-model="item.descripcion"
                          label="Descripción"
                          maxlength="50"
                          minlenght="0"
                          :counter="15"
                          outlined
                        ></v-text-field>
                      </td>
                      <td class="text-center" colspan="3">
                        <v-text-field
                          v-model="item.plan"
                          label="Plan"
                          maxlength="50"
                          minlenght="0"
                          :counter="15"
                          outlined
                        ></v-text-field>
                      </td>
                    </tr>
                  </template>
                </tbody>
              </template>
            </v-simple-table>
            <v-row>
              <v-col md="12" class="justify-center">
                <div class="btn d-flex justify-center mt-6">
                  <v-btn
                    class="
                      button-text
                      v-btn v-btn--outlined v-btn--rounded
                      theme--light
                      v-size--default
                      tway-violet--text
                      justify-center
                    "
                    outlined
                    color="indigo lighten-2"
                    @click="AddItem()"
                  >
                    <v-icon color="purple">mdi-plus</v-icon>
                    Agregar otro
                  </v-btn>
                </div>
              </v-col>
            </v-row>
          </div>
        </v-card>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
export default {
  data: () => ({
    dialog: false,
    ocurrencia: ["1", "2", "3", "4", "5", "6"],
    impacto: ["Insignificante", "Menor", "Moderado", "Mayor", "Catastrófico"],
    estado: ["Levantado", "Gestionado", "Pendiente", "Atrasado"],
    categoria: ["Proceso", "Ambiente", "Materiales", "Equipo"],
    responsable: ["Andrea", "Francisco", "Aldo", "César"],
    estrategia: ["Mitigar", "Transferir", "Escalar"],
    items: [
      {
        ocurrencia: "",
        impacto: "",
        estado: "",
        categoria: "",
        riesgo: "",
        responsable: "",
        estrategia: "",
        descripcion: "",
        plan: "",
      },
    ],
    nameRules: [
      (v) => !!v || "Requerido.",
      (v) => v.length <= 15 || "Máximo 15 carácteres.",
    ],
    isVisible: false,
    activeClass: "is-visible",
    date: new Date(Date.now() - new Date().getTimezoneOffset() * 60000)
      .toISOString()
      .substr(0, 10),
    date2: new Date(Date.now() - new Date().getTimezoneOffset() * 60000)
      .toISOString()
      .substr(0, 10),
    menu2: false,
    menu3: false,
    isShow: true,
  }),
  methods: {
    AddItem() {
      this.items.push({
        anio: this.anio,
        mes: this.mes,
        costo: this.costo,
        total: this.total,
        monto: this.monto,
      });
    },
    removeItem() {
      if (this.items.length > 1) {
        this.items.splice(this.items, 1);
      }
    },
    saveItem(item) {
      item.isVisible = !item.isVisible;
      this.$forceUpdate();
    },
  },
};
</script>

<style>
.shrink {
  width: 150px;
}
.bar {
  width: 350px;
}
.modalSystem {
  border-radius: 0px !important;
}
.v-menu__content.theme--light.v-menu__content--fixed.menuable__content__active {
  background-color: #fff;
}
.modalSystem .v-card.v-sheet.theme--light {
  padding: 20px 40px;
}
.modalSystem label.v-label.theme--light,
.edit_row .v-text-field__details {
  font-family: "Josefin Sans", sans-serif !important;
}
.modalSystem fieldset {
  border-color: #4a148c !important;
}
.modalSystem label.v-label--active {
  color: #4a148c !important;
}
.modalSystem button.v-btn.primary {
  background-color: #4a148c !important;
  border-color: #4a148c !important;
}
.modalSystem button.float-right {
  z-index: 9;
  top: 15px;
  right: 15px;
  position: absolute;
}
.edit_row .v-input__slot,
.edit_row .v-select {
  min-height: 35px !important;
  max-height: 35px !important;
  margin-bottom: 0px !important;
}
.edit_row .v-text-field--outlined .v-label {
  top: 8px;
  font-size: 13px !important;
}
.edit_row .v-input__append-inner {
  margin-top: 5px !important;
}
.v-text-field__details {
  display: none;
}
.edit_row .v-select__selection,
.edit_row .v-text-field__slot input {
  font-size: 0.875rem;
}
.edit_row label.v-label.v-label--active.theme--light {
  top: 18px;
}
tr.edit_row td {
  height: 60px !important;
}
.modalSystem .edit_row fieldset {
  border-color: #fff !important;
  background-color: #f2f2f2;
}
.modalSystem .v-data-table__wrapper {
  max-height: 408px;
  overflow: auto;
}
.peso {
  float: left;
  margin-right: 5px;
  top: 7px;
  position: relative;
}
tr.edit_row td .edit {
  display: none;
}
tr.edit_row.is-visible td {
  pointer-events: none;
}
tr.edit_row.is-visible td.buttons {
  pointer-events: visible;
}
tr.edit_row.is-visible td .save {
  display: none !important;
}
tr.edit_row.is-visible td .edit {
  display: inline-grid !important;
}
tr.edit_row.is-visible .v-input__append-inner {
  display: none !important;
}
tr.edit_row.is-visible label.v-label.v-label--active.theme--light {
  display: none;
}
.modalSystem .edit_row.is-visible fieldset {
  border-color: transparent !important;
  background-color: transparent;
}
.formSeg .formRow {
  display: none;
}
.formSeg .formRow:last-child {
  display: flex;
}
.edit_row
  .v-input.v-input--is-label-active.v-input--is-dirty.theme--light.v-text-field.v-text-field--is-booted.v-text-field--enclosed.v-text-field--outlined
  .v-input__prepend-outer {
  display: none;
}
.v-data-table__wrapper .edit_row th.text-center {
  color: rgba(0, 0, 0, 0.6);
}
</style>
